<?php namespace Validators;
// AUTOGENERATED BY laravel-validator FROM test/fixtures/recursive-example.js, PLEASE, DON'T MODIFY IT

use App;
use Input;
use Log;
use Str;

class RecursiveExample {

  public static function validate() {
    return self::validateData(Input::all());
  }

  public static function error($data, $msg) {
    $bt = debug_backtrace();
    $caller = array_shift($bt);
    Log::error($msg);
    Log::debug($caller['file'] . '::' . $caller['line']);
    Log::debug(var_export($data, TRUE));
    App::abort(403, 'validator error: ' . $msg);
  }

  public static function validateData($data) {
    $valid = array();
    $store = array();

    if (!is_array($data)) {
      self::error($data, 'root is not an array');
    }

    if (!isset($data['myobj'])) {
      $data['myobj'] = null;
    }

    $value = $data['myobj'];
    if (is_null($value)) {
      $value = array();
    }
    if (!is_array($value)) {
      self::error($data, 'key ' . 'myobj' . ' is not an object');
    }
    $valid['myobj'] = array();

    if (!isset($data['myobj']['fstring'])) {
      $data['myobj']['fstring'] = null;
    }

    $value = $data['myobj']['fstring'];
    if (is_null($value)) {
      $value = '';
    }
    if (is_int($value) || is_float($value)) {
      $value = strval($value);
    }
    if (!is_string($value)) {
      self::error($data, 'key ' . 'fstring' . ' is not a string');
    }

    $valid['myobj']['fstring'] = $value;

    if (!isset($data['myobj']['fobj2'])) {
      $data['myobj']['fobj2'] = null;
    }

    $value = $data['myobj']['fobj2'];
    if (is_null($value)) {
      $value = array();
    }
    if (!is_array($value)) {
      self::error($data, 'key ' . 'fobj2' . ' is not an object');
    }
    $valid['myobj']['fobj2'] = array();

    if (!isset($data['myobj']['fobj2']['finteger'])) {
      $data['myobj']['fobj2']['finteger'] = null;
    }

    $value = $data['myobj']['fobj2']['finteger'];
    if (is_null($value)) {
      $value = 0;
    }
    if (is_string($value)) {
      if (ctype_digit($value)) {
        $value = intval($value);
      }
    }
    if (!is_int($value)) {
      self::error($data, 'key ' . 'finteger' . ' is not an integer');
    }

    $valid['myobj']['fobj2']['finteger'] = $value;

    if (!isset($data['farr1'])) {
      $data['farr1'] = null;
    }

    $value = $data['farr1'];
    if (is_null($value)) {
      $value = array();
    }
    if (!is_array($value)) {
      self::error($data, 'key ' . 'farr1' . ' is not an array');
    }
    if (count($value) < 0) {
      self::error($data, 'array ' . 'farr1' . ' has less than 0 items');
    }
    $valid['farr1'] = array();

    $size0 = count($data['farr1']);
    for ($i0 = 0; $i0 < $size0; $i0++) {
      if (!isset($data['farr1'][$i0])) {
        self::error($data, 'array has not key ' . $i0);
      }

      $value = $data['farr1'][$i0];
      if (is_null($value)) {
        $value = '';
      }
      if (is_int($value) || is_float($value)) {
        $value = strval($value);
      }
      if (!is_string($value)) {
        self::error($data, 'key ' . $i0 . ' is not a string');
      }

      $valid['farr1'][$i0] = $value;

    }

    if (!isset($data['farr'])) {
      $data['farr'] = null;
    }

    $value = $data['farr'];
    if (is_null($value)) {
      $value = array();
    }
    if (!is_array($value)) {
      self::error($data, 'key ' . 'farr' . ' is not an array');
    }
    if (count($value) < 2) {
      self::error($data, 'array ' . 'farr' . ' has less than 2 items');
    }
    $valid['farr'] = array();

    $size1 = count($data['farr']);
    for ($i1 = 0; $i1 < $size1; $i1++) {
      if (!isset($data['farr'][$i1])) {
        self::error($data, 'array has not key ' . $i1);
      }

      $value = $data['farr'][$i1];
      if (is_null($value)) {
        $value = '';
      }
      if (is_int($value) || is_float($value)) {
        $value = strval($value);
      }
      if (!is_string($value)) {
        self::error($data, 'key ' . $i1 . ' is not a string');
      }

      $valid['farr'][$i1] = $value;

    }

    if (!isset($data['params'])) {
      $data['params'] = null;
    }

    $value = $data['params'];
    if (is_null($value)) {
      $value = '';
    }
    if (is_int($value) || is_float($value)) {
      $value = strval($value);
    }
    if (!is_string($value)) {
      self::error($data, 'key ' . 'params' . ' is not a string');
    }

    if (Str::length($value) === 0) {
      self::error($data, 'key ' . 'params' . ' breaks the required validation');
    }

    $valid['params'] = $value;

    if (!isset($data['farrobj'])) {
      $data['farrobj'] = null;
    }

    $value = $data['farrobj'];
    if (is_null($value)) {
      $value = array();
    }
    if (!is_array($value)) {
      self::error($data, 'key ' . 'farrobj' . ' is not an array');
    }
    if (count($value) < 0) {
      self::error($data, 'array ' . 'farrobj' . ' has less than 0 items');
    }
    $valid['farrobj'] = array();

    $size2 = count($data['farrobj']);
    for ($i2 = 0; $i2 < $size2; $i2++) {
      if (!isset($data['farrobj'][$i2])) {
        self::error($data, 'array has not key ' . $i2);
      }

      $value = $data['farrobj'][$i2];
      if (is_null($value)) {
        $value = array();
      }
      if (!is_array($value)) {
        self::error($data, 'key ' . $i2 . ' is not an object');
      }
      $valid['farrobj'][$i2] = array();

      if (!isset($data['farrobj'][$i2]['fstring'])) {
        $data['farrobj'][$i2]['fstring'] = null;
      }

      $value = $data['farrobj'][$i2]['fstring'];
      if (is_null($value)) {
        $value = '';
      }
      if (is_int($value) || is_float($value)) {
        $value = strval($value);
      }
      if (!is_string($value)) {
        self::error($data, 'key ' . 'fstring' . ' is not a string');
      }

      if (Str::length($value) === 0) {
        self::error($data, 'key ' . 'fstring' . ' breaks the required validation');
      }

      $valid['farrobj'][$i2]['fstring'] = $value;

    }

    if (!isset($data['farr1'])) {
      $data['farr1'] = null;
    }

    $value = $data['farr1'];
    if (is_null($value)) {
      $value = array();
    }
    if (!is_array($value)) {
      self::error($data, 'key ' . 'farr1' . ' is not an array');
    }
    if (count($value) < 0) {
      self::error($data, 'array ' . 'farr1' . ' has less than 0 items');
    }
    $valid['farr1'] = array();

    $size3 = count($data['farr1']);
    for ($i3 = 0; $i3 < $size3; $i3++) {
      if (!isset($data['farr1'][$i3])) {
        self::error($data, 'array has not key ' . $i3);
      }

      $value = $data['farr1'][$i3];
      if (is_null($value)) {
        $value = array();
      }
      if (!is_array($value)) {
        self::error($data, 'key ' . $i3 . ' is not an array');
      }
      if (count($value) < 0) {
        self::error($data, 'array ' . $i3 . ' has less than 0 items');
      }
      $valid['farr1'][$i3] = array();

      $size4 = count($data['farr1'][$i3]);
      for ($i4 = 0; $i4 < $size4; $i4++) {
        if (!isset($data['farr1'][$i3][$i4])) {
          self::error($data, 'array has not key ' . $i4);
        }

        $value = $data['farr1'][$i3][$i4];
        if (is_null($value)) {
          $value = array();
        }
        if (!is_array($value)) {
          self::error($data, 'key ' . $i4 . ' is not an array');
        }
        if (count($value) < 0) {
          self::error($data, 'array ' . $i4 . ' has less than 0 items');
        }
        $valid['farr1'][$i3][$i4] = array();

        $size5 = count($data['farr1'][$i3][$i4]);
        for ($i5 = 0; $i5 < $size5; $i5++) {
          if (!isset($data['farr1'][$i3][$i4][$i5])) {
            self::error($data, 'array has not key ' . $i5);
          }

          $value = $data['farr1'][$i3][$i4][$i5];
          if (is_null($value)) {
            $value = array();
          }
          if (!is_array($value)) {
            self::error($data, 'key ' . $i5 . ' is not an object');
          }
          $valid['farr1'][$i3][$i4][$i5] = array();

          if (!isset($data['farr1'][$i3][$i4][$i5]['inner'])) {
            $data['farr1'][$i3][$i4][$i5]['inner'] = null;
          }

          $value = $data['farr1'][$i3][$i4][$i5]['inner'];
          if (is_string($value)) {
            if ($value === 'true' || $value === '1' || $value === 'on') {
              $value = true;
            }
            if ($value === 'false' || $value === '0' || $value === 'off') {
              $value = false;
            }
          }
          if (is_int($value)) {
            if ($value === 1) {
              $value = true;
            }
            if ($value === 0) {
              $value = false;
            }
          }
          if (!is_bool($value)) {
            self::error($data, 'key ' . 'inner' . ' is not a boolean');
          }

          $valid['farr1'][$i3][$i4][$i5]['inner'] = $value;

        }

      }

    }

    if (!isset($data['ffoo'])) {
      $data['ffoo'] = null;
    }

    $value = $data['ffoo'];
    if (is_null($value)) {
      $value = '';
    }
    if (is_int($value) || is_float($value)) {
      $value = strval($value);
    }
    if (!is_string($value)) {
      self::error($data, 'key ' . 'ffoo' . ' is not a string');
    }

    $store['foo'] = $value;

    $valid['ffoo'] = $value;

    if (!isset($data['fbar'])) {
      $data['fbar'] = null;
    }

    $value = $data['fbar'];
    if (is_null($value)) {
      $value = '';
    }
    if (is_int($value) || is_float($value)) {
      $value = strval($value);
    }
    if (!is_string($value)) {
      self::error($data, 'key ' . 'fbar' . ' is not a string');
    }

    $store['bar'] = $value;

    $valid['fbar'] = $value;

    if ($store["foo"] === "bar") {

      if (!isset($data['conditional'])) {
        $data['conditional'] = null;
      }

      $value = $data['conditional'];
      if (is_null($value)) {
        $value = array();
      }
      if (!is_array($value)) {
        self::error($data, 'key ' . 'conditional' . ' is not an object');
      }
      $valid['conditional'] = array();

      if (!isset($data['conditional']['fstring'])) {
        $data['conditional']['fstring'] = null;
      }

      $value = $data['conditional']['fstring'];
      if (is_null($value)) {
        $value = '';
      }
      if (is_int($value) || is_float($value)) {
        $value = strval($value);
      }
      if (!is_string($value)) {
        self::error($data, 'key ' . 'fstring' . ' is not a string');
      }

      $valid['conditional']['fstring'] = $value;

    }

    if (true) {

      if (!isset($data['mystr'])) {
        $data['mystr'] = null;
      }

      $value = $data['mystr'];
      if (is_null($value)) {
        $value = '';
      }
      if (is_int($value) || is_float($value)) {
        $value = strval($value);
      }
      if (!is_string($value)) {
        self::error($data, 'key ' . 'mystr' . ' is not a string');
      }

      if (Str::length($value) === 0) {
        self::error($data, 'key ' . 'mystr' . ' breaks the required validation');
      }

      $valid['mystr'] = $value;

    }

    if (false) {

      if (!isset($data['myarr'])) {
        $data['myarr'] = null;
      }

      $value = $data['myarr'];
      if (is_null($value)) {
        $value = array();
      }
      if (!is_array($value)) {
        self::error($data, 'key ' . 'myarr' . ' is not an array');
      }
      if (count($value) < 0) {
        self::error($data, 'array ' . 'myarr' . ' has less than 0 items');
      }
      $valid['myarr'] = array();

      $size6 = count($data['myarr']);
      for ($i6 = 0; $i6 < $size6; $i6++) {
        if (!isset($data['myarr'][$i6])) {
          self::error($data, 'array has not key ' . $i6);
        }

        $value = $data['myarr'][$i6];
        if (is_null($value)) {
          $value = 0;
        }
        if (is_string($value)) {
          if (ctype_digit($value)) {
            $value = intval($value);
          }
        }
        if (!is_int($value)) {
          self::error($data, 'key ' . $i6 . ' is not an integer');
        }

        $valid['myarr'][$i6] = $value;

      }

    }

    if (false) {

      if (!isset($data['myarr_extended'])) {
        $data['myarr_extended'] = null;
      }

      $value = $data['myarr_extended'];
      if (is_null($value)) {
        $value = array();
      }
      if (!is_array($value)) {
        self::error($data, 'key ' . 'myarr_extended' . ' is not an object');
      }
      $valid['myarr_extended'] = array();

      if ($store["bar"] === "bar") {

        if (!isset($data['myarr_extended']['qux'])) {
          $data['myarr_extended']['qux'] = null;
        }

        $value = $data['myarr_extended']['qux'];
        if (is_null($value)) {
          $value = array();
        }
        if (!is_array($value)) {
          self::error($data, 'key ' . 'qux' . ' is not an object');
        }
        $valid['myarr_extended']['qux'] = array();

        if (!isset($data['myarr_extended']['qux']['myqux'])) {
          $data['myarr_extended']['qux']['myqux'] = null;
        }

        $value = $data['myarr_extended']['qux']['myqux'];
        if (is_string($value)) {
          if ($value === 'true' || $value === '1' || $value === 'on') {
            $value = true;
          }
          if ($value === 'false' || $value === '0' || $value === 'off') {
            $value = false;
          }
        }
        if (is_int($value)) {
          if ($value === 1) {
            $value = true;
          }
          if ($value === 0) {
            $value = false;
          }
        }
        if (!is_bool($value)) {
          self::error($data, 'key ' . 'myqux' . ' is not a boolean');
        }

        $valid['myarr_extended']['qux']['myqux'] = $value;

      }

    }

    if ($store["bar"] === "baz") {

      if (!isset($data['foo'])) {
        $data['foo'] = null;
      }

      $value = $data['foo'];
      if (is_null($value)) {
        $value = '';
      }
      if (is_int($value) || is_float($value)) {
        $value = strval($value);
      }
      if (!is_string($value)) {
        self::error($data, 'key ' . 'foo' . ' is not a string');
      }

      if (Str::length($value) === 0) {
        self::error($data, 'key ' . 'foo' . ' breaks the required validation');
      }

      $valid['foo'] = $value;

    }

    if ($store["bar"] === "qux") {

      if (!isset($data['foo'])) {
        $data['foo'] = null;
      }

      $value = $data['foo'];
      if (is_null($value)) {
        $value = 0;
      }
      if (is_string($value)) {
        if (ctype_digit($value)) {
          $value = intval($value);
        }
      }
      if (!is_int($value)) {
        self::error($data, 'key ' . 'foo' . ' is not an integer');
      }

      if ($value < 0) {
        self::error($data, 'key ' . 'foo' . ' breaks the positive validation');
      }

      $valid['foo'] = $value;

    }

    if (!isset($data['example'])) {
      $data['example'] = null;
    }

    $value = $data['example'];
    if (is_null($value)) {
      $value = '';
    }
    if (is_int($value) || is_float($value)) {
      $value = strval($value);
    }
    if (!is_string($value)) {
      self::error($data, 'key ' . 'example' . ' is not a string');
    }

    if (Str::length($value) === 0) {
      self::error($data, 'key ' . 'example' . ' breaks the required validation');
    }

    if (!in_array($value, array('before,after', 'before2,after2'), TRUE)) {
      self::error($data, 'key ' . 'example' . ' breaks the in validation');
    }

    $valid['example'] = $value;

    return $valid;
  }

}
